﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SyncfusionMvcApplication121;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript;
using Syncfusion.Linq;
using System.Collections;
namespace SyncfusionMvcApplication121.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        public static List<Orders> order = new List<Orders>();

        public void BindDataSource()
        {
            if (order.Count == 0)
            {
                for (var i = 0; i < 10; i++)
                {
                    order.Add(new Orders(10001 + 1 + i, 1, "ALFKI" + i, new DateTime(1996, 5, 6), "Berlin"));
                    order.Add(new Orders(10002 + 2 + i, 2, "Bob" + i, new DateTime(1992, 3, 1), "USA"));
                    order.Add(new Orders(10003 + 3 + i, 3, "Danny" + i, new DateTime(1990, 2, 7), "Australia"));
                    order.Add(new Orders(10004 + 4 + i, 4, "Jack" + i, new DateTime(2016, 4, 5), "ASIA"));
                    order.Add(new Orders(10005 + 5 + i, 5, "Robert" + i, new DateTime(2016, 5, 5), "ASIA"));
                    order.Add(new Orders(10006 + 6 + i, 6, "Watson" + i, new DateTime(2011, 2, 5), "CANADA"));
                    order.Add(new Orders(10007 + 7 + i, 7, "JUSTIN" + i, new DateTime(2012, 3, 5), "EASTAFRICA"));
                    order.Add(new Orders(10008 + 8 + i, 8, "AKON" + i, new DateTime(2012, 3, 5), "AFRICA"));
                    order.Add(new Orders(10009 + 9 + i, 9, "MARK" + i, new DateTime(2012, 3, 5), "CANADA"));
                    order.Add(new Orders(10010 + 10 + i, 10, "REHMAN" + i, new DateTime(2012, 3, 5), "INDIA"));
                    order.Add(new Orders(10011 + 11 + i, 11, "STEVE" + i, new DateTime(2012, 3, 5), "USA"));
                    order.Add(new Orders(10012 + 12 + i, 12, "SMITH" + i, new DateTime(2012, 3, 5), "AFGAN"));
                    order.Add(new Orders(10013 + 13 + i, 13, "WILL" + i, new DateTime(2012, 3, 5), "CHINA"));
                    order.Add(new Orders(10014 + 14 + i, 14, "WOLVERINE" + i, new DateTime(2012, 3, 5), "JAPAN"));
                    order.Add(new Orders(10015 + 15 + i, 15, "DRAGON" + i, new DateTime(2012, 3, 5), "CANADA"));
                    if(i==999)
                        order.Add(new Orders(10015 + 15 + i, 15, "DRAGON" + i, new DateTime(2017, 3, 5), "CANADA"));
                }
            }
        }

        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderID, int EmployeeID, string CustomerId, DateTime OrderDate, string ShipCity)
            {
                this.OrderID = OrderID;
                this.EmployeeID = EmployeeID;
                this.CustomerID = CustomerId;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;

            }
            public long OrderID { get; set; }
            public int EmployeeID { get; set; }
            public string CustomerID { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }

        }
        public ActionResult GridFeatures()
        {
            BindDataSource();
            ViewBag.datasource = order.ToList();
            return View();
        }
        //public ActionResult DataSource(DataManager dm)
        //{
        //    BindDataSource();
        //    IEnumerable DataSource = order.ToList();
        //    DataResult result = new DataResult();
        //    DataOperations operation = new DataOperations();
        //    result.result = DataSource;
        //    if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
        //    {
        //        result.result = operation.PerformSorting(result.result, dm.Sorted);
        //    }
        //    if (dm.Where != null && dm.Where.Count > 0) //Filtering
        //    {
        //        result.result = operation.PerformWhereFilter(DataSource, dm.Where, dm.Where[0].Operator);
        //    }
        //    result.count = result.result.AsQueryable().Count();
        //    if (dm.Skip > 0)
        //        result.result = operation.PerformSkip(result.result, dm.Skip);
        //    if (dm.Take > 0)
        //        result.result = operation.PerformTake(result.result, dm.Take);

        //    return Json(new { result = result.result, count = result.count }, JsonRequestBehavior.AllowGet);
        //}
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
            public IEnumerable data { get; set; }
        }
    }
}
